/* 

   This code was ported to the Sega Dreamcast ( all rights reserved )
   using KOS ( http://dcdev.allusion.net/ ) and its addon library KGL.
   
   It was ported by Stephen Bolton ( aka HyperG - hyper_gamer13@hotmail.com ).
   
   The BMP source code included with this port was coded by Paul Boese  ( http://www.axlen.com/ ).
   
   I also would like to thank Flecko for helping me get started with OpenGL.
   
*/

/* IMPORTANT NOTICE -- THIS CODE IS PARTIALLY CODED, MEANING THE BLENDING EFFECTS DO
   NOT WORK BECAUSE KOS KGL DOES NOT SUPPORT IT YET.*/

//
// This code was created by Jeff Molofee '99 (ported to Solaris/GLUT by Lakmal Gunasekara '99)
//
// If you've found this code useful, please let me know.
//
// Visit me at www.demonews.com/hosted/nehe 
// (email Richard Campbell at ulmont@bellsouth.net)
// (email Lakmal Gunasekara at lakmal@gunasekara.de)
//
#include <kos.h>
#include <GL\gl.h>			// Header File For The OpenGL32 Library
#include <GL\glu.h>			// Header File For The GLu32 Library
#include "bmp.h"

/* lighting on/off (1 = on, 0 = off) */
//int light;

/* L pressed (1 = yes, 0 = no) */
//int lp;

/* F pressed (1 = yes, 0 = no) */
//int fp;


GLfloat xrot;   // x rotation 
GLfloat yrot;   // y rotation 
GLfloat xspeed; // x rotation speed
GLfloat yspeed; // y rotation speed

GLfloat z=-5.0f; // depth into the screen.

/* white ambient light at half intensity (rgba) */
//GLfloat LightAmbient[] = { 0.5f, 0.5f, 0.5f, 1.0f };

/* super bright, full intensity diffuse light. */
//GLfloat LightDiffuse[] = { 1.0f, 1.0f, 1.0f, 1.0f };

/* position of light (x, y, z, (position of light)) */
//GLfloat LightPosition[] = { 0.0f, 0.0f, 2.0f, 1.0f };

//GLuint	filter;			/* Which Filter To Use (nearest/linear/mipmapped) */
//GLuint  blend;                  /* Turn blending on/off */

//-------Start of DC Image Stuff------//

/* Load a texture using pcx_load_texture and glKosTex2D */
void loadtxr(const char *fn, GLuint *txr, GLint texformat, int alpha) {
	uint32 txaddr;
	int w, h;
	if (pcx_load_texture(fn, 1, alpha, &txaddr, &w, &h) < 0) {
		printf("can't load %s\n", fn);
		return;
	}

	glGenTextures(1, txr);
	glBindTexture(GL_TEXTURE_2D, *txr);
	glKosTex2D(texformat, w, h, txaddr);
}

// Loads a BMP file to a texture  - Use with transparent polys!
// BMP file should be at least 256x256.
// Black (R=G=B=0) is transparent.
void loadbmptxr(const char *fn, GLuint *txr) {
	uint32 txaddr;
	int w, h;

	BITMAP *myBmp;

	myBmp=load_bmp(fn);
	if (NULL != myBmp) {
		w = myBmp->nWidth;
		h = myBmp->nHeight;
		txaddr = ta_txr_allocate(w * h *2);
		ta_txr_load(txaddr, myBmp->data, w * h *2); 
		//txr_to_alpha(myBmp->data, w, h);
		//txr_twiddle_copy(myBmp->data, w, h, txaddr, w, h, 0);
		free(myBmp);
		printf("%s %dx%d\n", fn, w, h);
	} else {
		printf("*** %s didn't load ***\n", fn);
		return;
	}
	
	glGenTextures(1, txr);
	glBindTexture(GL_TEXTURE_2D, *txr);
	glKosTex2D(GL_ARGB1555, w, h, txaddr);
}

//--------End of DC Image format-------//

/* The function called when our window is resized (which shouldn't happen, because we're fullscreen) */
GLvoid ReSizeGLScene()
{
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();

    gluPerspective(45.0f,640.0f/480.0f,0.1f,100.0f);
    glMatrixMode(GL_MODELVIEW);
}

/* The main drawing function. */
void cube(GLuint texture) {
        glEnable(GL_TEXTURE_2D);
	glEnable(GL_KOS_AUTO_UV);

    glLoadIdentity();				// Reset The View

    glTranslatef(0.0f,0.0f,z);                  // move z units out from the screen.
    
    glRotatef(xrot,1.0f,0.0f,0.0f);		// Rotate On The X Axis
    glRotatef(yrot,0.0f,1.0f,0.0f);		// Rotate On The Y Axis

    glBindTexture(GL_TEXTURE_2D, texture);   // choose the texture to use. /*[filter]*//is taken off temporary until KOS supports light etc.

    glBegin(GL_QUADS);		                // begin drawing a cube
    
    // Front Face (note that the texture's corners have to match the quad's corners)
    glNormal3f( 0.0f, 0.0f, 1.0f);      // front face points out of the screen on z.
    glVertex3f(-1.0f, 1.0f, 1.0f);	// Bottom Left Of The Texture and Quad
    glVertex3f(1.0f, 1.0f, 1.0f);	// Bottom Right Of The Texture and Quad
    glVertex3f(1.0f, -1.0f, 1.0f);	// Top Right Of The Texture and Quad
    glVertex3f(-1.0f, -1.0f, 1.0f);	// Top Left Of The Texture and Quad
    
    // Back Face
    glNormal3f( 0.0f, 0.0f,-1.0f);      // back face points into the screen on z.
    glVertex3f(-1.0f, -1.0f, -1.0f);	// Bottom Right Of The Texture and Quad
    glVertex3f(1.0f, -1.0f, -1.0f);	// Top Right Of The Texture and Quad
    glVertex3f(1.0f, 1.0f, -1.0f);	// Top Left Of The Texture and Quad
    glVertex3f(-1.0f, 1.0f, -1.0f);	// Bottom Left Of The Texture and Quad
    
    // Left Face
    glNormal3f(-1.0f, 0.0f, 0.0f);      // left face points left on x.
    glVertex3f(-1.0f, 1.0f, 1.0f);	// Bottom Left Of The Texture and Quad
    glVertex3f(-1.0f, -1.0f, 1.0f);	// Bottom Right Of The Texture and Quad
    glVertex3f(-1.0f, -1.0f, -1.0f);	// Top Right Of The Texture and Quad
    glVertex3f(-1.0f, 1.0f, -1.0f);	// Top Left Of The Texture and Quad
    
    // Right face
    glNormal3f( 1.0f, 0.0f, 0.0f);      // right face points right on x.
    glVertex3f(1.0f, 1.0f, -1.0f);	// Bottom Right Of The Texture and Quad
    glVertex3f(1.0f, -1.0f, -1.0f);	// Top Right Of The Texture and Quad
    glVertex3f(1.0f, -1.0f, 1.0f);	// Top Left Of The Texture and Quad
    glVertex3f(1.0f, 1.0f, 1.0f);	// Bottom Left Of The Texture and Quad
	
    // Top Face
    glNormal3f( 0.0f, 1.0f, 0.0f);      // top face points up on y.
    glVertex3f(1.0f, 1.0f, 1.0f);	// Top Left Of The Texture and Quad
    glVertex3f(-1.0f, 1.0f, 1.0f);	// Bottom Left Of The Texture and Quad
    glVertex3f(-1.0f, 1.0f, -1.0f);	// Bottom Right Of The Texture and Quad
    glVertex3f(1.0f, 1.0f, -1.0f);	// Top Right Of The Texture and Quad
    
    // Bottom Face       
    glNormal3f( 0.0f, -1.0f, 0.0f);     // bottom face points down on y. 
    glVertex3f(1.0f, -1.0f, -1.0f);	// Top Right Of The Texture and Quad
    glVertex3f(-1.0f, -1.0f, -1.0f);	// Top Left Of The Texture and Quad
    glVertex3f(-1.0f, -1.0f, 1.0f);	// Bottom Left Of The Texture and Quad
    glVertex3f(1.0f, -1.0f, 1.0f);	// Bottom Right Of The Texture and Quad
    
    glEnd();                                    // done with the polygon.

    xrot+=xspeed;		                // X Axis Rotation	
    yrot+=yspeed;		                // Y Axis Rotation
    glDisable(GL_KOS_AUTO_UV);
    glDisable(GL_TEXTURE_2D);
}

/* The blending stuff for the control is in the cygwin source code,
   which is what this source code is based off */

extern uint8 romdisk[];
int main(int argc, char **argv) 
{
	uint8 c;
	cont_cond_t cond;
	GLuint tex_glass;
	
	kos_init_all(THD_ENABLE | IRQ_ENABLE | TA_ENABLE, romdisk);	// set up KOS    

        glKosInit();
        glEnable(GL_TEXTURE_2D);                    // Enable texture mapping.
        glEnable(GL_CULL_FACE);	
    
        loadbmptxr("/rd/glass.bmp", &tex_glass);
        c = maple_first_controller();
        glShadeModel(GL_SMOOTH);			// Enables Smooth Color Shading
    
        glMatrixMode(GL_PROJECTION);
        glLoadIdentity();				// Reset The Projection Matrix
    
        glMatrixMode(GL_MODELVIEW);
        
        // set up light number 1.
        //glLightfv(GL_LIGHT1, GL_AMBIENT, LightAmbient);  // add lighting. (ambient)
       //glLightfv(GL_LIGHT1, GL_DIFFUSE, LightDiffuse);  // add lighting. (diffuse).
       //glLightfv(GL_LIGHT1, GL_POSITION,LightPosition); // set light position.
       //glEnable(GL_LIGHT1);                             // turn light 1 on.
    
       /* setup blending */
       //glBlendFunc(GL_SRC_ALPHA,GL_ONE);			// Set The Blending Function For Translucency
       //glColor4f(1.0f, 1.0f, 1.0f, 0.5);
	
while(1) 
							// Infinite loop, the best kind			
	{
		/* Check key status */
		if (cont_get_cond(c, &cond) < 0)
			break;
		if (!(cond.buttons & CONT_DPAD_DOWN))
		        z+=0.02f;      // move the cube closer.
		if (!(cond.buttons & CONT_DPAD_UP))
		        z-=0.02f;      // move the cube into the distance.
	        if (!(cond.buttons & CONT_X))
	           	xspeed+=0.01f; // increase x rotation speed;
	        if (!(cond.buttons & CONT_Y)) 	
	        	xspeed-=0.01f; // decrease x rotation speed;
	        if (!(cond.buttons & CONT_A))
	                yspeed+=0.01f; // increase y rotation speed;
	        if (!(cond.buttons & CONT_B))
	                yspeed-=0.01f; // decrease y rotation speed;
	        if (!(cond.buttons & CONT_START))
		        break;	       // Stops program
	                 
		glKosBeginFrame();     // Tell KOS to start the frame
		ReSizeGLScene();       // This isn't really a needed function...but you get the idea
		cube(tex_glass);       // Draw the scene
		glKosFinishFrame();    // Tell KOS you're done with the frame
	}
	
	return 0;
}